#include <config.h>

#include <stdio.h>
#include <string.h>
#include <glib.h>
#include <time.h>

#include "gtoonz.h"

/********************************************************************
 *                     CARTOON FUNCTION PROTOTYPE                   *
 * void cartoon_name (Cartoon *cartoon, int year, int month, int day);  *
 ********************************************************************/

static void
simple_make_url (Cartoon *cartoon, int year, int month, int day,
                 const char *buffer, int pages)
{
	Item *item;
	int i;

	for (i = 1; i < pages+1; i++)
	{
		item = g_new0 (Item, 1);
		item->url = g_new (char, strlen(buffer) +10);
		sprintf(item->url, buffer, year, month, day, i);
		cartoon->item_list = g_slist_append (cartoon->item_list, item);
	}
}

static void
donga_make_url (Cartoon *cartoon, int year, int month, int day,
                const char *buffer, int pages)
{
	Item *item;
	int i;

	for (i = 1; i < pages+1; i++)
	{
		item = g_new0 (Item, 1);
		item->url = g_new (char, strlen(buffer) +10);
		sprintf(item->url, buffer, year, month, month, day, i);
		cartoon->item_list = g_slist_append (cartoon->item_list, item);
	}
}

static void
sportsseoul_make_url (Cartoon *cartoon, int year, int month, int day,
                      const char *buffer, time_t begin, int pages)
{
	Item *item;
	time_t delta;	/* 1999.4.6 01:00:00 */
	struct tm t;
	int i;

	t.tm_sec = 0;
	t.tm_min = 0;
	t.tm_hour = 1;
	t.tm_mday = day;
	t.tm_mon = month - 1;
	t.tm_year = year-1900;

	delta = ( (mktime(&t)-begin) * 6/ (60*60*24*7) );

	for (i = 1; i < pages+1; i++)
	{
		item = g_new0 (Item, 1);
		item->url = g_new (char, strlen(buffer) +10);
		sprintf(item->url, buffer, delta,i);
		cartoon->item_list = g_slist_append (cartoon->item_list, item);
	}
}

/* Don't worry. It works well */
static void
ilkan_make_url( Cartoon *cartoon, int year, int month, int day, int num )
{
	Item *item;
	FILE *file;
	int i, j = 1;
	int length;
	char buf[ 1024 ];
	char sys_exec[] = "wget http://sports.hankooki.com/comic/cartoon/  .htm "
	                  "--directory-prefix /tmp";
	char img_url[] = "toon/img/  /%s";

	sys_exec[ 46 ] = ( num / 10 ) + '0';
	sys_exec[ 47 ] = ( num % 10 ) + '0';
	system( sys_exec );

	strncpy( sys_exec + 41, "/tmp", 4 );
	sys_exec[ 52 ] = '\0';

	if ( ( file = fopen( sys_exec + 41, "r" ) ) == NULL )
	{
		return;
	}

	img_url[ 9  ] = ( num / 10 ) + '0';
	img_url[ 10 ] = ( num % 10 ) + '0';

	strcpy( sys_exec + 41, img_url );

	while ( fgets( buf, 1024, file ) != NULL )
	{
		for ( i = 0, length = strlen( buf ); i < length; i++ )
		{
			if ( !strncmp( buf + i, ".jpg", 3 ) )
			{
				item = g_new0( Item, 1 );
				item->url = g_new( char, 69 );

				buf[ i + 4 ] = '\0';
				sprintf( item->url, sys_exec + 5, buf + i - 16 );
				cartoon->item_list = g_slist_append (cartoon->item_list, item);
			}
		}
	}

	strncpy( sys_exec + 45, "/tmp", 4 );
	strncpy( sys_exec + 52, ".htm", 5 );

	fclose( file );
	printf( "%s\n", sys_exec + 45 );
	unlink( sys_exec + 45 );
}

void
ttodi (Cartoon *cartoon, int year, int month, int day)
{
	ilkan_make_url( cartoon, year, month, day, 3 );

	return;
}

static void
aseak (Cartoon *cartoon, int year, int month, int day)
{
	ilkan_make_url( cartoon, year, month, day, 7 );

	return;
}

static void
detul (Cartoon *cartoon, int year, int month, int day)
{
	ilkan_make_url( cartoon, year, month, day, 2 );

	return;
}

static void
mafia (Cartoon *cartoon, int year, int month, int day)
{
	ilkan_make_url( cartoon, year, month, day, 4 );

	return;
}

static void
haderi (Cartoon *cartoon, int year, int month, int day)
{
	ilkan_make_url( cartoon, year, month, day, 11 );

	return;
}

static void
tobak (Cartoon *cartoon, int year, int month, int day)
{
	ilkan_make_url( cartoon, year, month, day, 9 );

	return;
}

static void
blondy (Cartoon *cartoon, int year, int month, int day)
{
	ilkan_make_url( cartoon, year, month, day, 5 );

	return;
}

static void
skmp (Cartoon *cartoon, int year, int month, int day)
{
	ilkan_make_url( cartoon, year, month, day, 6 );

	return;
}

static void
simin (Cartoon *cartoon, int year, int month, int day)
{
	const char *URL = "http://cartoon.stoo.com/simin/data/%d%02d%02dsimin_%d.jpg";
	simple_make_url( cartoon, year, month, day, URL, 2 );

	return;
}

static void
melang (Cartoon *cartoon, int year, int month, int day)
{
	const char *URL = "http://cartoon.stoo.com/melang/data/%d%02d%02dmelang_%d.jpg";
	simple_make_url( cartoon, year, month, day, URL, 2 );

	return;
}

static void
wonderful (Cartoon *cartoon, int year, int month, int day)
{
	const char *URL = "http://cartoon.stoo.com/wonderful/data/%d%02d%02dworld_%d.jpg";
	simple_make_url( cartoon, year, month, day, URL, 2 );

	return;
}

static void
gaepae (Cartoon *cartoon, int year, int month, int day)
{
	const char *URL = "http://cartoon.stoo.com/gaepae/data/%d%02d%02dgaepae.jpg";
	simple_make_url( cartoon, year, month, day, URL, 1 );

	return;
}

static void
choong (Cartoon *cartoon, int year, int month, int day)
{
	const char *URL = "http://cartoon.stoo.com/choong/data/%d%02d%02dchoong.jpg";
	simple_make_url( cartoon, year, month, day, URL, 1 );

	return;
}

static void
movie (Cartoon *cartoon, int year, int month, int day)
{
	const char *URL = "http://cartoon.stoo.com/movie/data/%d%02d%02dmovie.jpg";
	simple_make_url( cartoon, year, month, day, URL, 1 );

	return;
}

static void
arirang (Cartoon *cartoon, int year, int month, int day)
{
	const char *URL = "http://cartoon.stoo.com/arirang/data/%d%02d%02darirang.jpg";
	simple_make_url( cartoon, year, month, day, URL, 1 );

	return;
}

static void
yasa (Cartoon *cartoon, int year, int month, int day)
{
	const char *URL = "http://cartoon.stoo.com/yasa/data/%d%02d%02dyasa.jpg";
	simple_make_url( cartoon, year, month, day, URL, 1 );

	return;
}

static void
tazza (Cartoon *cartoon, int year, int month, int day)
{
	const char *URL = "http://manhwa.sportschosun.com/enter/cartoon/tazza/image_cartoon/%d%02d%02dc.gif";
	simple_make_url( cartoon, year, month, day, URL, 1 );

	return;
}

static void
zombie (Cartoon *cartoon, int year, int month, int day)
{
	const char *URL = "http://manhwa.sportschosun.com/enter/cartoon/zombi/image_cartoon/%d%02d%02dk.gif";
	simple_make_url( cartoon, year, month, day, URL, 1 );

	return;
}

static void
good (Cartoon *cartoon, int year, int month, int day)
{
	const char *URL = "http://manhwa.sportschosun.com/enter/cartoon/good/image_cartoon/%d%02d%02da.gif";
	simple_make_url( cartoon, year, month, day, URL, 1 );

	return;
}

static void
henggarae (Cartoon *cartoon, int year, int month, int day)
{
	const char *URL = "http://manhwa.sportschosun.com/enter/cartoon/henggarae/image_cartoon/%d%02d%02de.gif";
	simple_make_url( cartoon, year, month, day, URL, 1 );

	return;
}

static void
fist (Cartoon *cartoon, int year, int month, int day)
{
	const char *URL = "http://manhwa.sportschosun.com/enter/cartoon/fist/image_cartoon/%d%02d%02dj.gif";
	simple_make_url( cartoon, year, month, day, URL, 1 );

	return;
}

static void
moodaeri (Cartoon *cartoon, int year, int month, int day)
{
	const char *URL = "http://www.sportsseoul.com/html/comic/yong/%d/3%d.gif";
	sportsseoul_make_url ( cartoon, year, month, day, URL, 925196400, 4 );

	return;
}

static void
myth (Cartoon *cartoon, int year, int month, int day)
{
	const char *URL = "http://www.sportsseoul.com/html/comic/myth/%d/%d.gif";
	sportsseoul_make_url ( cartoon, year, month, day, URL, 1024723819, 6 );

	return;
}

static void
sisa (Cartoon *cartoon, int year, int month, int day)
{
	const char *URL = "http://www.sportsseoul.com/html/comic/sisa/%d/1.gif";
	sportsseoul_make_url ( cartoon, year, month, day, URL, 991934664, 1 );

	return;
}

static void
sikgaek (Cartoon *cartoon, int year, int month, int day)
{
	const char *URL = "http://www.donga.com/docs/cartoon/sg/%d%02d/sg%02d%02d_%d.jpg";
	donga_make_url( cartoon, year, month, day, URL, 4 );

	return;
}


static void
nadaero (Cartoon *cartoon, int year, int month, int day)
{
	const char *URL = "http://www.donga.com/docs/cartoon/nadaero/%d%02d/me%02d%02d.gif";
	donga_make_url( cartoon, year, month, day, URL, 1 );

	return;
}

static void
c386 (Cartoon *cartoon, int year, int month, int day)
{
	const char *URL = "http://www.donga.com/docs/cartoon/386c/%d%02d/386c%02d%02d.jpg";
	donga_make_url( cartoon, year, month, day, URL, 1 );

	return;
}

static void
snowcat (Cartoon *cartoon, int year, int month, int day)
{
	const char *URL = "http://snowcat.co.kr/diary/%s%02d/%s%02d%02d.gif";
	Item *item;
	char year_s[5] = {0};

	item = g_new0 (Item, 1);
	item->url = g_new (char, strlen(URL) + 10);
	sprintf (year_s, "%d", year);
	sprintf(item->url, URL, year_s + 2, month, year_s + 2, month, day);
	cartoon->item_list = g_slist_append (cartoon->item_list, item);

	return;
}

static void
marineblues (Cartoon *cartoon, int year, int month, int day)
{
	const char *URL = "http://www.marineblues.net/mb/note/image2/%d-%d.jpg";
	Item *item;

	item = g_new0 (Item, 1);
	item->url = g_new (char, strlen(URL) +10);
	sprintf( item->url, URL, month, day );
	cartoon->item_list = g_slist_append (cartoon->item_list, item);

	return;
}

CartoonInfo CartoonInfoList[N_CARTOONS] =
{
/* ϰ  */
	{TTODI, N_("ttodi"),			"jpg", 1, &ttodi},
	{ASEAK, N_("aseak"),			"jpg", 1, &aseak},
	{DETUL, N_("detul"),			"jpg", 3, &detul},
	{MAFIA, N_("mafia"),			"jpg", 3, &mafia},
	{HADERI, N_("haderi"),			"jpg", 1, &haderi},
	{TOBAK, N_("tobak"),			"jpg", 1, &tobak},
	{BLONDY, N_("blondy"),			"jpg", 1, &blondy},
	{SKMP, N_("skmp"),				"jpg", 1, &skmp},
	/*   */
	{SIMIN, N_("simin"),			"jpg", 2, &simin},
	{MELANG, N_("melang"),			"jpg", 2, &melang},
	{WONDERFUL, N_("wonderful"),	"jpg", 2, &wonderful},
	{GAEPAE, N_("gaepae"),			"jpg", 1, &gaepae},
	{CHOONG, N_("choong"),			"jpg", 1, &choong},
	{MOVIE, N_("movie"),			"jpg", 1, &movie},
	{ARIRANG, N_("arirang"),		"jpg", 1, &arirang},
	{YASA, N_("yasa"),				"jpg", 1, &yasa},
	/*   */
	{TAZZA, N_("tazza"),			"gif", 1, &tazza},
	{ZOMBIE, N_("zombie"),			"gif", 1, &zombie},
	{GOOD, N_("good"),				"gif", 1, &good},
	{HENGGARAE, N_("henggarae"),	"gif", 1, &henggarae},
	{FIST, N_("fist"),				"gif", 1, &fist},
	/*   */
	{MOODAERI, N_("moodaeri"),		"gif", 4, &moodaeri},
	{MYTH, N_("myth"),				"gif", 6, &myth},
	{SISA, N_("sisa"),				"gif", 1, &sisa},
	/* Ϻ */
	{SIKGAEK, N_("sikgaek"),		"jpg", 4, &sikgaek},
	{NADAERO, N_("nadaero"),		"gif", 1, &nadaero},
	{C386, N_("386c"),				"jpg", 1, &c386},
	/*   */
	{SNOWCAT, N_("snowcat"),		"gif", 1, &snowcat},
	{MARINEBLUES, N_("marineblues"),"jpg", 1, &marineblues}
};
